from rocolib.api.components.Component import Component

c = Component()

c.addParameter("tlength", 156, paramType="length")
c.addParameter("twidth", 90, paramType="length")
c.addParameter("tdepth", 70, paramType="length")

c.addSubcomponent("cabin","Cabin", inherit="depth")
c.addConstraint(("cabin","width"), "twidth") #cabin depth and length can be anything

c.addSubcomponent("boat","BoatBase", root=True, inherit=True)
c.addConstraint(("boat","boat.length"), "tlength")
c.addConstraint(("boat","boat.width"), "twidth")
c.addConstraint(("boat","boat.depth"), "tdepth")
c.addConstraint(("boat","bow.point"), "tlength", "x/2.")
c.addConstraint(("boat","stern.point"), "tlength", "x/8.")

c.addSubcomponent("portsplit", "SplitEdge")
c.addConstraint(("portsplit", "toplength"), ("tlength"), "(x,)")
c.addConstraint(("portsplit", "botlength"), ("tlength", "cabin.depth"), "(0.5 * x[0] - 0.5 * x[1], x[1], 0.5 * x[0] - 0.5 * x[1])")

c.addConnection(("cabin", "foreedge"), ("portsplit", "botedge1"))
c.addConnection(("boat", "portedge"), ("portsplit", "topedge0"))

#
c.addSubcomponent("starsplit", "SplitEdge")
c.addConstraint(("starsplit", "toplength"), ("tlength"), "(x,)")
c.addConstraint(("starsplit", "botlength"), ("tlength", "cabin.depth"), "(0.5 * x[0] - 0.5 * x[1], x[1], 0.5 * x[0] - 0.5 * x[1])")

c.addConnection(("cabin", "rearedge"), ("starsplit", "botedge1"), tabWidth=10)
c.addConnection(("boat", "staredge"), ("starsplit", "topedge0"))
#

c.inheritInterface(("portedge"), ("boat", "portedge"))
c.inheritInterface(("staredge"), ("boat", "staredge"))

c.toLibrary("Tug")
