from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("boat", "Tug", inherit=True)
c.inheritAllInterfaces("boat")

c.addConstConstraint(("boat", "length"), 156)
c.addConstConstraint(("boat", "width"), 90)
c.addConstConstraint(("boat", "depth"), 70)

c.addSubcomponent("servostack", "ServoStackMount")
c.inheritAllInterfaces("servostack")

# c.addConnection(("boat", "portedge"), ("servostack", "lTopSplit")) #both face the same direction
# c.addConnection(("boat", "staredge"), ("servostack", "rTopSplit"))

c.addSubcomponent("batterymount", "BatteryMount")
c.inheritAllInterfaces("batterymount")
#
c.addSubcomponent("portsplit", "SplitEdge")
c.inheritAllInterfaces("portsplit")
c.addConstConstraint(("portsplit", "toplength"), (156,)) #156-61
c.addConstConstraint(("portsplit", "botlength"), (61, 10, 24, 61))

c.addConnection(("portsplit", "topedge0"), ("boat", "portedge"))

c.addConnection(("portsplit", "botedge0"), ("servostack", "lstacksplit"))
c.addConnection(("portsplit", "botedge2"), ("servostack", "lservosplit"))
c.addConnection(("batterymount", "leftArmInterface"),("portsplit", "botedge3"), tabWidth=10)

c.addSubcomponent("starsplit", "SplitEdge")
c.inheritAllInterfaces("starsplit")
c.addConstConstraint(("starsplit", "toplength"), (156,))
c.addConstConstraint(("starsplit", "botlength"), (61, 24, 10, 61))

c.addConnection(("starsplit", "topedge0"), ("boat", "staredge"))

c.addConnection(("starsplit", "botedge3"), ("servostack", "rstacksplit"))
c.addConnection(("starsplit", "botedge1"), ("servostack", "rservosplit"))
c.addConnection(("batterymount", "rightArmInterface"),("starsplit", "botedge0"), tabWidth=10)

c.toLibrary("HouseboatWithServoStackBattery")
