from rocolib.api.components import Component

c = Component()

c.addSubcomponent("left", "PaddlewheelL", inherit=True, prefix=None)
c.addSubcomponent("right", "PaddlewheelR")

c.addConstraint(("right", "Radius"), "Radius")
c.addConstraint(("right", "PanelLength"), "PanelLength")
c.addConstraint(("right", "Spokes"), "Spokes")

for i in range(8):
    c.addSubcomponent("flapsplitL%d" % i, "SplitEdge")
    c.addSubcomponent("flapsplitR%d" % i, "SplitEdge")

    c.addConstraint(("flapsplitL%d" % i, "botlength"), ("Radius", "PanelLength"),
                    "[3.*x[0]/24, 3.*x[0]/24, 3.*x[0]/24]")
    c.addConstraint(("flapsplitL%d" % i, "toplength"), ("Radius", "PanelLength"), "[3.*x[0]/8]")

    c.addConstraint(("flapsplitR%d" % i, "botlength"), ("Radius", "PanelLength"),
                    "[3.*x[0]/24, 3.*x[0]/24, 3.*x[0]/24]")
    c.addConstraint(("flapsplitR%d" % i, "toplength"), ("Radius", "PanelLength"), "[3.*x[0]/8]")

    c.addConnection(("flapsplitR%d" % i, "topedge0"), ("right", "flap%dR" % i))
    c.addConnection(("flapsplitL%d" % i, "topedge0"), ("left", "flap%dL" % i))
    c.addConnection(("flapsplitL%d" % i, "botedge2"), ("flapsplitR%d" % i, "botedge2"), angle=0, tabWidth=5)

for i in range(8):
    c.addSubcomponent("flapsplitRsup%d" % i, "SplitEdge")
    c.addConstraint(("flapsplitRsup%d" % i, "botlength"), ("Radius", "PanelLength"), "[3.*x[0]/24]")
    c.addConstraint(("flapsplitRsup%d" % i, "toplength"), ("Radius", "PanelLength"), "[3.*x[0]/24]")
    c.addConnection(("flapsplitRsup%d" % i, "botedge0"), ("flapsplitR%d" % i, "botedge1"))
    c.addConnection(("flapsplitRsup%d" % i, "topedge0"), ("flapsplitL%d" % i, "botedge1"), angle=0, tabWidth=5)

# c.addConnection(("left", "flap%dL" %i), ("right", "flap%dR" %i), angle=0, tabWidth=4)

# for i in range(12):
# c.addConnection(("left", "flap%dL" %i), ("right", "flap%dR" %i), angle=0, tabWidth=4)

c.toLibrary("PaddleWheel")
